const getAllColumns = (columns, parentColumn, _rowspan = 0) => {
  const result = []
  columns.forEach((column) => {
    column.parentId = parentColumn ? parentColumn.id : null
    if (column.visible) {
      column._rowspan = _rowspan
      if (column.children && column.children.length && column.children.some(column => column.visible)) {
        result.push(column)
        result.push(...getAllColumns(column.children, column, _rowspan + column.rowSpan || 1))
      } else {
        result.push(column)
      }
    }
  })
  return result
}

export const convertToRows = (originColumns) => {
  let maxLevel = 1
  const traverse = (column, parent) => {
    if (parent) {
      const _rowSpan = parent.rowSpan || 1
      column.level = parent.level + _rowSpan
      if (maxLevel < column.level) {
        maxLevel = column.level
      }
    }
    if (column.children && column.children.length && column.children.some(column => column.visible)) {
      let colSpan = 0
      column.children.forEach((subColumn) => {
        if (subColumn.visible) {
          traverse(subColumn, column)
          colSpan += subColumn.colSpan
        }
      })
      column.colSpan = colSpan
    } else {
      column.colSpan = 1
    }
  }

  originColumns.forEach((column) => {
    column.level = 1
    traverse(column)
  })

  const rows = []
  for (let i = 0; i < maxLevel; i++) {
    rows.push([])
  }

  const allColumns = getAllColumns(originColumns)

  allColumns.forEach((column) => {
    // if (column.children && column.children.length && column.children.some(column => column.visible)) {
    //   column.rowSpan = 1
    // } else {
    //   column.rowSpan = maxLevel - column.level + 1
    // }
    if (column.children && column.children.length && column.children.some(column => column.visible)) {
      column.rowSpan = column.rowSpan || 1
    } else {
      column.rowSpan = maxLevel - column._rowspan
    }
    rows[column.level - 1].push(column)
  })

  return rows
}
